!!ARBfp1.0

# polomer svietidla
PARAM radius=program.local[0];

# pomocny vektor
TEMP dist;

# skalarny sucin poloha vrcholu . vektor A
DP3 dist.x,fragment.texcoord[0],fragment.texcoord[1];
ADD dist.x,dist.x,fragment.texcoord[1].w;
MAX dist.x,dist.x,-dist.x;

# skalarny sucin poloha vrcholu . vektor B
DP3 dist.y,fragment.texcoord[0],fragment.texcoord[2];
ADD dist.y,dist.y,fragment.texcoord[2].w;
MAX dist.y,-dist.y,0;

# skalarny sucin poloha vrcholu . vektor C
DP3 dist.z,fragment.texcoord[0],fragment.texcoord[3];
ADD dist.z,dist.z,fragment.texcoord[3].w;
MAX dist.z,dist.z,0;

# dist.w=dist.x * dist.x + dist.y * dist.y + dist.z * dist.z
DP3 dist.w,dist,dist;

# dist.w=1 / sqrt(dist.w)
RSQ dist.w,dist.w;

# dist=1 / dist.w
RCP dist,dist.w;

# dist=dist * radius.x
MUL dist,dist,radius.x;

# vyber farby pixelu z 1D textury
TEX result.color,dist,texture[0],1D;

END
