!!ARBfp1.0

# farba trubice
PARAM color=program.local[0];

# pomocne vektory
TEMP point;
TEMP tcolor1,tcolor2,normal;
TEMP dir,diffuse;

# ziskanie farby z texturovacej jednotky 1 - normalmapa
# hodnota sa transformuje z intervalu [0,1] do intervalu [-1,1]
TEX tcolor1,fragment.texcoord[6],texture[0],2D;
MAD tcolor1,tcolor1,2.0,-1.0;

# normalizacia vektora DP3+RSQ+MUL
DP3 tcolor1.w,tcolor1,tcolor1;
RSQ tcolor1.w,tcolor1.w;
MUL tcolor1,tcolor1,tcolor1.w;

# ziskanie farby z texturovacej jednotky 2 - klasicka textura
TEX tcolor2,fragment.texcoord[6],texture[1],2D;

# vypocet normaly na zaklade TBN a normalmapy
DP3 normal.x,fragment.texcoord[3],tcolor1;
DP3 normal.y,fragment.texcoord[4],tcolor1;
DP3 normal.z,fragment.texcoord[5],tcolor1;

# vypocet polohy vrcholu
DP3 point.w,fragment.texcoord[0],fragment.texcoord[2];
SUB point.w,point.w,fragment.texcoord[1].w;
MUL_SAT point.w,point.w,fragment.texcoord[2].w;
MAD point,fragment.texcoord[2],point.w,fragment.texcoord[1];

# pozn.: _SAT znamena, ze vysledne hodnoty budu lezat v intervale [0,1]

# vypocet smeroveho vektora
SUB dir,point,fragment.texcoord[0];

# normalizacia vektora DP3+RSQ+MUL
DP3 dir.w,dir,dir;
RSQ dir.w,dir.w;
MUL dir.xyz,dir,dir.w;

# vypocet difuznej zlozky svetla (+orazanie do [0,1])
DP3_SAT diffuse,dir,normal;

# vypocet vyslednej farby pixela po aplikacii difuzneho osvetlenia a utlmu
MUL dir.w,dir.w,color.w;
MUL diffuse,diffuse,dir.w;
MUL diffuse,diffuse,color;
MUL result.color,tcolor2,diffuse;

END
